import type { Options, DefResponse, Storage, Interceptor, Request, Response, DriverRequest } from './types';
export interface Params extends Options {
    reqSet: {
        add: (x: string) => void;
        get: () => Set<string>;
    };
    _onReqStarted: (request: Request) => void;
    _onMatch: (interceptor: Interceptor, req: Request) => void;
    storage: Storage;
}
export interface BeforeRespondArg {
    respond: (response: Response, interceptor: Interceptor) => Promise<void>;
    request: Request;
    response: DefResponse;
    responseOverrides?: Partial<Response>;
    interceptor: Interceptor;
    mog: Function;
    increment: () => number;
}
export default function createHandler(initialParams: Params): ({ request, abort, next, respond }: DriverRequest, extraParams?: Partial<Params>) => Promise<void>;
