import type { UserOptions, Driver, Storage, UserInterceptor, Spy } from './types';
declare class Teremock {
    private defaultOptions;
    private extraParams?;
    private options;
    private storage;
    /** set of urls of currently active connections. all connections became inactive after response. */
    private reqSet;
    /** set of urls of currently active connections, which cleared only on connections resolve */
    private reqSetRet;
    private alive;
    private reqsPromise?;
    private removeCloseHandler?;
    private removeRequestHandler?;
    private removeResponseHandler?;
    protected driver: Driver | undefined;
    private _startPromise?;
    private _resolveReqs;
    private _spies;
    private _interceptors;
    private _matched;
    private _requestPendingQueue?;
    private _responsePendingQueue?;
    constructor(opts?: {
        storage?: Storage;
        driver?: Driver;
    });
    private _onAnyReqStart;
    private _onAnyReqEnd;
    start(userOptions: UserOptions): Promise<any>;
    add(userInterceptor: UserInterceptor, overwrite?: boolean): () => void;
    remove(userInterceptor: UserInterceptor): void;
    connections(opts?: {
        timeout: number;
    }): Promise<any>;
    spy(spyInterceptor: UserInterceptor): Spy;
    stop(opts?: {
        safe?: boolean;
    }): Promise<void>;
}
export default Teremock;
