import debug from 'debug';
import type { Request, Response, Options, UserOptions, Interceptor, UserInterceptor } from './types';
export declare const loggerTrace: debug.Debugger;
export declare function assignResponse(response1: Response, response2?: Partial<Response>): Response;
export interface InParams {
    interceptors: Record<string, Interceptor>;
    request: Request;
}
export interface TimeStampWithStrictOrder {
    timestamp: number;
    order: number;
}
export declare const getTimeStampWithStrictOrder: () => TimeStampWithStrictOrder;
export declare const isInterceptorMatched: (interceptor: Interceptor, request: Request) => boolean;
export declare const findInterceptor: ({ interceptors, request }: InParams) => Interceptor | null;
export declare function getQuery(url: string): Record<string, string>;
export declare function isBodyMatched(value: any, request: Request): boolean;
export declare function getFormData(body: Request['body']): Record<string, string>;
export interface ParsedUrl {
    query: Record<string, string>;
    location: string;
}
export declare function parseUrl(url: string): ParsedUrl;
export declare function blacklist(source: Response['headers'] | undefined, list: string[]): Response['headers'] | undefined;
export declare function userInterceptorToInterceptor(uint: UserInterceptor, nameArg?: string): Interceptor;
export declare function userOptionsToOptions(defaultOptions: Options, userOptions: UserOptions): Options;
export declare const getBody: (body: Object | string | undefined | null) => string | undefined;
export declare class AsyncPendingQueue {
    protected allSettledPromise: Promise<unknown>;
    protected _errorsCount: number;
    add<T>(promise: Promise<T>): Promise<T>;
    awaitPending(): Promise<number>;
}
